Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/mppini.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/mppini.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/mppini.F90	(revision 13727)
@@ -875,7 +837,7 @@
          iszitst = ( nx_global+2-2*nn_hls + (ji-1) ) / ji + 2*nn_hls    ! first  dim.
 #else
-         iszitst = ( jpiglo - 2*nn_hls + (ji-1) ) / ji + 2*nn_hls
+         iszitst = ( Ni0glo + (ji-1) ) / ji + 2*nn_hls   ! max subdomain i-size
 #endif
-         IF( iszitst < isziref ) THEN
+         IF( iszitst < isziref .AND. iszitst >= iszimin ) THEN
             isziref = iszitst
             inbimax = inbimax + 1
@@ -886,7 +848,7 @@
          iszjtst = ( ny_global+2-2*nn_hls + (ji-1) ) / ji + 2*nn_hls    ! first  dim.
 #else
-         iszjtst = ( jpjglo - 2*nn_hls + (ji-1) ) / ji + 2*nn_hls
+         iszjtst = ( Nj0glo + (ji-1) ) / ji + 2*nn_hls   ! max subdomain j-size
 #endif
-         IF( iszjtst < iszjref ) THEN
+         IF( iszjtst < iszjref .AND. iszjtst >= iszjmin ) THEN
             iszjref = iszjtst
             inbjmax = inbjmax + 1
@@ -926,5 +888,5 @@
       iszij1(:) = iszi1(:) * iszj1(:)
 
-      ! if therr is no land and no print
+      ! if there is no land and no print
       IF( .NOT. llist .AND. numbot == -1 .AND. numbdy == -1 ) THEN
          ! get the smaller partition which gives the smallest subdomain size
@@ -945,4 +907,5 @@
          ii = MINLOC(iszij1, mask = inbij1 == inbij, dim = 1)   ! warning: send back the first occurence if multiple results
          IF ( iszij1(ii) < iszij ) THEN
+            ii = MINLOC( iszi1+iszj1, mask = iszij1 == iszij1(ii) .AND. inbij1 == inbij, dim = 1)  ! select the smaller perimeter if multiple min
             isz0 = isz0 + 1
             indexok(isz0) = ii
@@ -974,10 +937,10 @@
          ji = isz0   ! initialization with the largest value
          ALLOCATE( llisoce(inbi0(ji), inbj0(ji)) )
-         CALL mpp_init_isoce( inbi0(ji), inbj0(ji), llisoce ) ! Warning: must be call by all cores (call mpp_sum)
+         CALL mpp_is_ocean( llisoce )   ! Warning: must be call by all cores (call mpp_sum)
          inbijold = COUNT(llisoce)
          DEALLOCATE( llisoce )
          DO ji =isz0-1,1,-1
             ALLOCATE( llisoce(inbi0(ji), inbj0(ji)) )
-            CALL mpp_init_isoce( inbi0(ji), inbj0(ji), llisoce ) ! Warning: must be call by all cores (call mpp_sum)
+            CALL mpp_is_ocean( llisoce )   ! Warning: must be call by all cores (call mpp_sum)
             inbij = COUNT(llisoce)
             DEALLOCATE( llisoce )
@@ -1005,5 +968,5 @@
          ii = ii -1 
          ALLOCATE( llisoce(inbi0(ii), inbj0(ii)) )
-         CALL mpp_init_isoce( inbi0(ii), inbj0(ii), llisoce )            ! must be done by all core
+         CALL mpp_is_ocean( llisoce )            ! must be done by all core
          inbij = COUNT(llisoce)
          DEALLOCATE( llisoce )
@@ -1014,5 +977,5 @@
       DEALLOCATE( inbi0, inbj0 )
       !
-   END SUBROUTINE mpp_init_bestpartition
+   END SUBROUTINE bestpartition
    
    
@@ -1023,5 +986,5 @@
       !! ** Purpose : the the proportion of land points in the surface land-sea mask
       !!
-      !! ** Method  : read iproc strips (of length jpiglo) of the land-sea mask
+      !! ** Method  : read iproc strips (of length Ni0glo) of the land-sea mask
       !!----------------------------------------------------------------------
       REAL(wp), INTENT(  out) :: propland    ! proportion of land points in the global domain (between 0 and 1)
@@ -1040,5 +1003,5 @@
 
       ! number of processes reading the bathymetry file 
-      iproc = MINVAL( (/mppsize, jpjglo/2, 100/) )  ! read a least 2 lines, no more that 100 processes reading at the same time
+      iproc = MINVAL( (/mppsize, Nj0glo/2, 100/) )  ! read a least 2 lines, no more that 100 processes reading at the same time
       
       ! we want to read iproc strips of the land-sea mask. -> pick up iproc processes every idiv processes starting at 1
@@ -1050,10 +1013,10 @@
       IF( MOD( narea-1, idiv ) == 0 .AND. iarea < iproc ) THEN   ! beware idiv can be = to 1
          !
-         ijsz = jpjglo / iproc                                               ! width of the stripe to read
-         IF( iarea < MOD(jpjglo,iproc) ) ijsz = ijsz + 1
-         ijstr = iarea*(jpjglo/iproc) + MIN(iarea, MOD(jpjglo,iproc)) + 1    ! starting j position of the reading
+         ijsz = Nj0glo / iproc                                               ! width of the stripe to read
+         IF( iarea < MOD(Nj0glo,iproc) ) ijsz = ijsz + 1
+         ijstr = iarea*(Nj0glo/iproc) + MIN(iarea, MOD(Nj0glo,iproc)) + 1    ! starting j position of the reading
          !
-         ALLOCATE( lloce(jpiglo, ijsz) )                                     ! allocate the strip
-         CALL mpp_init_readbot_strip( ijstr, ijsz, lloce )
+         ALLOCATE( lloce(Ni0glo, ijsz) )                                     ! allocate the strip
+         CALL readbot_strip( ijstr, ijsz, lloce )
          inboce = COUNT(lloce)                                               ! number of ocean point in the stripe
          DEALLOCATE(lloce)
@@ -1064,28 +1027,34 @@
       CALL mpp_sum( 'mppini', inboce )   ! total number of ocean points over the global domain
       !
-      propland = REAL( jpiglo*jpjglo - inboce, wp ) / REAL( jpiglo*jpjglo, wp ) 
+      propland = REAL( Ni0glo*Nj0glo - inboce, wp ) / REAL( Ni0glo*Nj0glo, wp ) 
       !
    END SUBROUTINE mpp_init_landprop
    
    
-   SUBROUTINE mpp_init_isoce( knbi, knbj, ldisoce )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE mpp_init_nboce  ***
-      !!
-      !! ** Purpose : check for a mpi domain decomposition knbi x knbj which
-      !!              subdomains contain at least 1 ocean point
-      !!
-      !! ** Method  : read knbj strips (of length jpiglo) of the land-sea mask
-      !!----------------------------------------------------------------------
-      INTEGER,                       INTENT(in   ) ::   knbi, knbj     ! domain decomposition
-      LOGICAL, DIMENSION(knbi,knbj), INTENT(  out) ::   ldisoce        ! .true. if a sub domain constains 1 ocean point 
-      !
-      INTEGER, DIMENSION(knbi,knbj) ::   inboce                        ! number oce oce pint in each mpi subdomain
-      INTEGER, DIMENSION(knbi*knbj) ::   inboce_1d
+   SUBROUTINE mpp_is_ocean( ldisoce )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE mpp_is_ocean  ***
+      !!
+      !! ** Purpose : Check for a mpi domain decomposition inbi x inbj which
+      !!              subdomains, including 1 halo (even if nn_hls>1), contain
+      !!              at least 1 ocean point.
+      !!              We must indeed ensure that each subdomain that is a neighbour
+      !!              of a land subdomain as only land points on its boundary
+      !!              (inside the inner subdomain) with the land subdomain.
+      !!              This is needed to get the proper bondary conditions on
+      !!              a subdomain with a closed boundary.
+      !!
+      !! ** Method  : read inbj strips (of length Ni0glo) of the land-sea mask
+      !!----------------------------------------------------------------------
+      LOGICAL, DIMENSION(:,:), INTENT(  out) ::   ldisoce        ! .true. if a sub domain constains 1 ocean point 
+      !
       INTEGER :: idiv, iimax, ijmax, iarea
+      INTEGER :: inbi, inbj, inx, iny, inry, isty
       INTEGER :: ji, jn
-      LOGICAL, ALLOCATABLE, DIMENSION(:,:) ::   lloce                  ! lloce(i,j) = .true. if the point (i,j) is ocean 
-      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   iimppt, ilci
-      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   ijmppt, ilcj
+      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   inboce           ! number oce oce pint in each mpi subdomain
+      INTEGER, ALLOCATABLE, DIMENSION(:  ) ::   inboce_1d
+      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   iimppt, ijpi
+      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   ijmppt, ijpj
+      LOGICAL, ALLOCATABLE, DIMENSION(:,:) ::   lloce            ! lloce(i,j) = .true. if the point (i,j) is ocean 
       !!----------------------------------------------------------------------
       ! do nothing if there is no land-sea mask
@@ -1094,43 +1063,88 @@
          RETURN
       ENDIF
-
-      ! we want to read knbj strips of the land-sea mask. -> pick up knbj processes every idiv processes starting at 1
-      IF           ( knbj == 1 ) THEN   ;   idiv = mppsize
-      ELSE IF ( mppsize < knbj ) THEN   ;   idiv = 1
-      ELSE                              ;   idiv = ( mppsize - 1 ) / ( knbj - 1 )
-      ENDIF
+      !
+      inbi = SIZE( ldisoce, dim = 1 )
+      inbj = SIZE( ldisoce, dim = 2 )
+      !
+      ! we want to read inbj strips of the land-sea mask. -> pick up inbj processes every idiv processes starting at 1
+      IF           ( inbj == 1 ) THEN   ;   idiv = mppsize
+      ELSE IF ( mppsize < inbj ) THEN   ;   idiv = 1
+      ELSE                              ;   idiv = ( mppsize - 1 ) / ( inbj - 1 )
+      ENDIF
+      !
+      ALLOCATE( inboce(inbi,inbj), inboce_1d(inbi*inbj) )
       inboce(:,:) = 0          ! default no ocean point found
-
-      DO jn = 0, (knbj-1)/mppsize   ! if mppsize < knbj : more strips than mpi processes (because of potential land domains)
+      !
+      DO jn = 0, (inbj-1)/mppsize   ! if mppsize < inbj : more strips than mpi processes (because of potential land domains)
          !
-         iarea = (narea-1)/idiv + jn * mppsize   ! involed process number (starting counting at 0)
-         IF( MOD( narea-1, idiv ) == 0 .AND. iarea < knbj ) THEN   ! beware idiv can be = to 1
+         iarea = (narea-1)/idiv + jn * mppsize + 1                     ! involed process number (starting counting at 1)
+         IF( MOD( narea-1, idiv ) == 0 .AND. iarea <= inbj ) THEN      ! beware idiv can be = to 1
             !
-            ALLOCATE( iimppt(knbi,knbj), ijmppt(knbi,knbj), ilci(knbi,knbj), ilcj(knbi,knbj) )
-            CALL mpp_basic_decomposition( knbi, knbj, iimax, ijmax, iimppt, ijmppt, ilci, ilcj )
+            ALLOCATE( iimppt(inbi,inbj), ijmppt(inbi,inbj), ijpi(inbi,inbj), ijpj(inbi,inbj) )
+            CALL mpp_basesplit( Ni0glo, Nj0glo, 0, inbi, inbj, iimax, ijmax, iimppt, ijmppt, ijpi, ijpj )
             !
-            ALLOCATE( lloce(jpiglo, ilcj(1,iarea+1)) )                                         ! allocate the strip
-            CALL mpp_init_readbot_strip( ijmppt(1,iarea+1), ilcj(1,iarea+1), lloce )           ! read the strip
-            DO  ji = 1, knbi
-               inboce(ji,iarea+1) = COUNT( lloce(iimppt(ji,1):iimppt(ji,1)+ilci(ji,1)-1,:) )   ! number of ocean point in subdomain
+            inx = Ni0glo + 2   ;   iny = ijpj(1,iarea) + 2             ! strip size + 1 halo on each direction (even if nn_hls>1)
+            ALLOCATE( lloce(inx, iny) )                                ! allocate the strip
+            inry = iny - COUNT( (/ iarea == 1, iarea == inbj /) )      ! number of point to read in y-direction
+            isty = 1 + COUNT( (/ iarea == 1 /) )                       ! read from the first or the second line?
+            CALL readbot_strip( ijmppt(1,iarea) - 2 + isty, inry, lloce(2:inx-1, isty:inry+isty-1) )   ! read the strip
+            ! 
+            IF( iarea == 1    ) THEN                                   ! the first line was not read
+               IF( jperio == 2 .OR. jperio == 7 ) THEN                 !   north-south periodocity
+                  CALL readbot_strip( Nj0glo, 1, lloce(2:inx-1, 1) )   !   read the last line -> first line of lloce
+               ELSE
+                  lloce(2:inx-1,  1) = .FALSE.                         !   closed boundary
+               ENDIF
+            ENDIF
+            IF( iarea == inbj ) THEN                                   ! the last line was not read
+               IF( jperio == 2 .OR. jperio == 7 ) THEN                 !   north-south periodocity
+                  CALL readbot_strip( 1, 1, lloce(2:inx-1,iny) )       !      read the first line -> last line of lloce
+               ELSEIF( jperio == 3 .OR. jperio == 4 ) THEN             !   north-pole folding T-pivot, T-point 
+                  lloce(2,iny) = lloce(2,iny-2)                        !      here we have 1 halo (even if nn_hls>1)
+                  DO ji = 3,inx-1
+                     lloce(ji,iny  ) = lloce(inx-ji+2,iny-2)           !      ok, we have at least 3 lines
+                  END DO
+                  DO ji = inx/2+2,inx-1
+                     lloce(ji,iny-1) = lloce(inx-ji+2,iny-1)
+                  END DO
+               ELSEIF( jperio == 5 .OR. jperio == 6 ) THEN             !   north-pole folding F-pivot, T-point, 1 halo
+                  lloce(inx/2+1,iny-1) = lloce(inx/2,iny-1)            !      here we have 1 halo (even if nn_hls>1)
+                  lloce(inx  -1,iny-1) = lloce(2    ,iny-1)
+                  DO ji = 2,inx-1
+                     lloce(ji,iny) = lloce(inx-ji+1,iny-1)
+                  END DO
+               ELSE                                                    !   closed boundary
+                  lloce(2:inx-1,iny) = .FALSE.
+               ENDIF
+            ENDIF
+            !                                                          ! first and last column were not read
+            IF( jperio == 1 .OR. jperio == 4 .OR. jperio == 6 .OR. jperio == 7 ) THEN
+               lloce(1,:) = lloce(inx-1,:)   ;   lloce(inx,:) = lloce(2,:)   ! east-west periodocity
+            ELSE
+               lloce(1,:) = .FALSE.          ;   lloce(inx,:) = .FALSE.      ! closed boundary
+            ENDIF
+            !
+            DO  ji = 1, inbi
+               inboce(ji,iarea) = COUNT( lloce(iimppt(ji,1):iimppt(ji,1)+ijpi(ji,1)+1,:) )   ! lloce as 2 points more than Ni0glo
             END DO
             !
             DEALLOCATE(lloce)
-            DEALLOCATE(iimppt, ijmppt, ilci, ilcj)
+            DEALLOCATE(iimppt, ijmppt, ijpi, ijpj)
             !
          ENDIF
       END DO
    
-      inboce_1d = RESHAPE(inboce, (/ knbi*knbj /))
+      inboce_1d = RESHAPE(inboce, (/ inbi*inbj /))
       CALL mpp_sum( 'mppini', inboce_1d )
-      inboce = RESHAPE(inboce_1d, (/knbi, knbj/))
+      inboce = RESHAPE(inboce_1d, (/inbi, inbj/))
       ldisoce(:,:) = inboce(:,:) /= 0
-      !
-   END SUBROUTINE mpp_init_isoce
+      DEALLOCATE(inboce, inboce_1d)
+      !
+   END SUBROUTINE mpp_is_ocean
    
    
-   SUBROUTINE mpp_init_readbot_strip( kjstr, kjcnt, ldoce )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE mpp_init_readbot_strip  ***
+   SUBROUTINE readbot_strip( kjstr, kjcnt, ldoce )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE readbot_strip  ***
       !!
       !! ** Purpose : Read relevant bathymetric information in order to
@@ -1138,36 +1152,89 @@
       !!              of land domains, in an mpp computation.
       !!
-      !! ** Method  : read stipe of size (jpiglo,...)
-      !!----------------------------------------------------------------------
-      INTEGER                         , INTENT(in   ) :: kjstr       ! starting j position of the reading
-      INTEGER                         , INTENT(in   ) :: kjcnt       ! number of lines to read
-      LOGICAL, DIMENSION(jpiglo,kjcnt), INTENT(  out) :: ldoce       ! ldoce(i,j) = .true. if the point (i,j) is ocean 
+      !! ** Method  : read stipe of size (Ni0glo,...)
+      !!----------------------------------------------------------------------
+      INTEGER                         , INTENT(in   ) ::   kjstr       ! starting j position of the reading
+      INTEGER                         , INTENT(in   ) ::   kjcnt       ! number of lines to read
+      LOGICAL, DIMENSION(Ni0glo,kjcnt), INTENT(  out) ::   ldoce       ! ldoce(i,j) = .true. if the point (i,j) is ocean 
       !
       INTEGER                           ::   inumsave                ! local logical unit
-      REAL(wp), DIMENSION(jpiglo,kjcnt) ::   zbot, zbdy 
+      REAL(wp), DIMENSION(Ni0glo,kjcnt) ::   zbot, zbdy 
       !!----------------------------------------------------------------------
       !
       inumsave = numout   ;   numout = numnul   !   redirect all print to /dev/null
       !
-      IF( numbot /= -1 ) THEN
-         CALL iom_get( numbot, jpdom_unknown, 'bottom_level', zbot, kstart = (/1,kjstr/), kcount = (/jpiglo, kjcnt/) )
+      IF( numbot /= -1 ) THEN   
+         CALL iom_get( numbot, jpdom_unknown, 'bottom_level', zbot, kstart = (/1,kjstr/), kcount = (/Ni0glo, kjcnt/) )
       ELSE
-         zbot(:,:) = 1.                         ! put a non-null value
-      ENDIF
-
-       IF( numbdy /= -1 ) THEN                  ! Adjust with bdy_msk if it exists    
-         CALL iom_get ( numbdy, jpdom_unknown, 'bdy_msk', zbdy, kstart = (/1,kjstr/), kcount = (/jpiglo, kjcnt/) )
+         zbot(:,:) = 1._wp                      ! put a non-null value
+      ENDIF
+      !
+      IF( numbdy /= -1 ) THEN                   ! Adjust with bdy_msk if it exists    
+         CALL iom_get ( numbdy, jpdom_unknown,     'bdy_msk', zbdy, kstart = (/1,kjstr/), kcount = (/Ni0glo, kjcnt/) )
          zbot(:,:) = zbot(:,:) * zbdy(:,:)
       ENDIF
       !
-      ldoce(:,:) = zbot(:,:) > 0.
+      ldoce(:,:) = zbot(:,:) > 0._wp
       numout = inumsave
       !
-   END SUBROUTINE mpp_init_readbot_strip
-
-
-   SUBROUTINE mpp_init_ioipsl
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE mpp_init_ioipsl  ***
+   END SUBROUTINE readbot_strip
+
+
+   SUBROUTINE mpp_getnum( ldisoce, kproc, kipos, kjpos )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE mpp_getnum  ***
+      !!
+      !! ** Purpose : give a number to each MPI subdomains (starting at 0)
+      !!
+      !! ** Method  : start from bottom left. First skip land subdomain, and finally use them if needed
+      !!----------------------------------------------------------------------
+      LOGICAL, DIMENSION(:,:), INTENT(in   ) ::   ldisoce     ! F if land process
+      INTEGER, DIMENSION(:,:), INTENT(  out) ::   kproc       ! subdomain number (-1 if supressed, starting at 0)
+      INTEGER, DIMENSION(  :), INTENT(  out) ::   kipos       ! i-position of the subdomain (from 1 to jpni)
+      INTEGER, DIMENSION(  :), INTENT(  out) ::   kjpos       ! j-position of the subdomain (from 1 to jpnj)
+      !
+      INTEGER :: ii, ij, jarea, iarea0
+      INTEGER :: icont, i2add , ini, inj, inij
+      !!----------------------------------------------------------------------
+      !
+      ini = SIZE(ldisoce, dim = 1)
+      inj = SIZE(ldisoce, dim = 2)
+      inij = SIZE(kipos)
+      !
+      ! specify which subdomains are oce subdomains; other are land subdomains
+      kproc(:,:) = -1
+      icont = -1
+      DO jarea = 1, ini*inj
+         iarea0 = jarea - 1
+         ii = 1 + MOD(iarea0,ini)
+         ij = 1 +     iarea0/ini
+         IF( ldisoce(ii,ij) ) THEN
+            icont = icont + 1
+            kproc(ii,ij) = icont
+            kipos(icont+1) = ii
+            kjpos(icont+1) = ij
+         ENDIF
+      END DO
+      ! if needed add some land subdomains to reach inij active subdomains
+      i2add = inij - COUNT( ldisoce )
+      DO jarea = 1, ini*inj
+         iarea0 = jarea - 1
+         ii = 1 + MOD(iarea0,ini)
+         ij = 1 +     iarea0/ini
+         IF( .NOT. ldisoce(ii,ij) .AND. i2add > 0 ) THEN
+            icont = icont + 1
+            kproc(ii,ij) = icont
+            kipos(icont+1) = ii
+            kjpos(icont+1) = ij
+            i2add = i2add - 1
+         ENDIF
+      END DO
+      !
+   END SUBROUTINE mpp_getnum
+
+
+   SUBROUTINE init_ioipsl
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE init_ioipsl  ***
       !!
       !! ** Purpose :   
@@ -1186,34 +1253,28 @@
       ! Set idompar values equivalent to the jpdom_local_noextra definition
       ! used in IOM. This works even if jpnij .ne. jpni*jpnj.
-      iglo(1) = jpiglo
-      iglo(2) = jpjglo
-      iloc(1) = nlci
-      iloc(2) = nlcj
-      iabsf(1) = nimppt(narea)
-      iabsf(2) = njmppt(narea)
+      iglo( :) = (/ Ni0glo, Nj0glo /)
+      iloc( :) = (/ Ni_0  , Nj_0   /)
+      iabsf(:) = (/ Nis0  , Njs0   /) + (/ nimpp, njmpp /) - 1 - nn_hls   ! corresponds to mig0(Nis0) but mig0 is not yet defined!
       iabsl(:) = iabsf(:) + iloc(:) - 1
-      ihals(1) = nldi - 1
-      ihals(2) = nldj - 1
-      ihale(1) = nlci - nlei
-      ihale(2) = nlcj - nlej
-      idid(1) = 1
-      idid(2) = 2
+      ihals(:) = (/ 0     , 0      /)
+      ihale(:) = (/ 0     , 0      /)
+      idid( :) = (/ 1     , 2      /)
 
       IF(lwp) THEN
           WRITE(numout,*)
-          WRITE(numout,*) 'mpp_init_ioipsl :   iloc  = ', iloc (1), iloc (2)
-          WRITE(numout,*) '~~~~~~~~~~~~~~~     iabsf = ', iabsf(1), iabsf(2)
-          WRITE(numout,*) '                    ihals = ', ihals(1), ihals(2)
-          WRITE(numout,*) '                    ihale = ', ihale(1), ihale(2)
+          WRITE(numout,*) 'mpp init_ioipsl :   iloc  = ', iloc
+          WRITE(numout,*) '~~~~~~~~~~~~~~~     iabsf = ', iabsf
+          WRITE(numout,*) '                    ihals = ', ihals
+          WRITE(numout,*) '                    ihale = ', ihale
       ENDIF
       !
       CALL flio_dom_set ( jpnij, nproc, idid, iglo, iloc, iabsf, iabsl, ihals, ihale, 'BOX', nidom)
       !
-   END SUBROUTINE mpp_init_ioipsl  
-
-
-   SUBROUTINE mpp_init_nfdcom
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE  mpp_init_nfdcom  ***
+   END SUBROUTINE init_ioipsl  
+
+
+   SUBROUTINE init_nfdcom
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE  init_nfdcom  ***
       !! ** Purpose :   Setup for north fold exchanges with explicit 
       !!                point-to-point messaging
@@ -1225,8 +1286,5 @@
       !!----------------------------------------------------------------------
       INTEGER  ::   sxM, dxM, sxT, dxT, jn
-      INTEGER  ::   njmppmax
-      !!----------------------------------------------------------------------
-      !
-      njmppmax = MAXVAL( njmppt )
+      !!----------------------------------------------------------------------
       !
       !initializes the north-fold communication variables
@@ -1234,8 +1292,8 @@
       nsndto     = 0
       !
-      IF ( njmpp == njmppmax ) THEN      ! if I am a process in the north
+      IF ( njmpp == MAXVAL( njmppt ) ) THEN      ! if I am a process in the north
          !
          !sxM is the first point (in the global domain) needed to compute the north-fold for the current process
-         sxM = jpiglo - nimppt(narea) - nlcit(narea) + 1
+         sxM = jpiglo - nimppt(narea) - jpiall(narea) + 1
          !dxM is the last point (in the global domain) needed to compute the north-fold for the current process
          dxM = jpiglo - nimppt(narea) + 2
@@ -1246,6 +1304,6 @@
          DO jn = 1, jpni
             !
-            sxT = nfiimpp(jn, jpnj)                            ! sxT = 1st  point (in the global domain) of the jn process
-            dxT = nfiimpp(jn, jpnj) + nfilcit(jn, jpnj) - 1    ! dxT = last point (in the global domain) of the jn process
+            sxT = nfimpp(jn)                    ! sxT = 1st  point (in the global domain) of the jn process
+            dxT = nfimpp(jn) + nfjpi(jn) - 1    ! dxT = last point (in the global domain) of the jn process
             !
             IF    ( sxT < sxM  .AND.  sxM < dxT ) THEN
@@ -1261,21 +1319,46 @@
             !
          END DO
-         nfsloop = 1
-         nfeloop = nlci
-         DO jn = 2,jpni-1
-            IF( nfipproc(jn,jpnj) == (narea - 1) ) THEN
-               IF( nfipproc(jn-1,jpnj) == -1 )   nfsloop = nldi
-               IF( nfipproc(jn+1,jpnj) == -1 )   nfeloop = nlei
-            ENDIF
-         END DO
          !
       ENDIF
       l_north_nogather = .TRUE.
       !
-   END SUBROUTINE mpp_init_nfdcom
-
-
-#endif
-
+   END SUBROUTINE init_nfdcom
+
+
+   SUBROUTINE init_doloop
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE init_doloop  ***
+      !!
+      !! ** Purpose :   set the starting/ending indices of DO-loop
+      !!              These indices are used in do_loop_substitute.h90
+      !!----------------------------------------------------------------------
+      !
+      Nis0 =   1+nn_hls   ;   Nis1 = Nis0-1   ;   Nis2 = MAX(  1, Nis0-2)
+      Njs0 =   1+nn_hls   ;   Njs1 = Njs0-1   ;   Njs2 = MAX(  1, Njs0-2)  
+      !                                                 
+      Nie0 = jpi-nn_hls   ;   Nie1 = Nie0+1   ;   Nie2 = MIN(jpi, Nie0+2)
+      Nje0 = jpj-nn_hls   ;   Nje1 = Nje0+1   ;   Nje2 = MIN(jpj, Nje0+2)
+      !
+      IF( nn_hls == 1 ) THEN          !* halo size of 1
+         !
+         Nis1nxt2 = Nis0   ;   Njs1nxt2 = Njs0
+         Nie1nxt2 = Nie0   ;   Nje1nxt2 = Nje0
+         !
+      ELSE                            !* larger halo size... 
+         !
+         Nis1nxt2 = Nis1   ;   Njs1nxt2 = Njs1
+         Nie1nxt2 = Nie1   ;   Nje1nxt2 = Nje1
+         !
+      ENDIF
+      !
+      Ni_0 = Nie0 - Nis0 + 1
+      Nj_0 = Nje0 - Njs0 + 1
+      Ni_1 = Nie1 - Nis1 + 1
+      Nj_1 = Nje1 - Njs1 + 1
+      Ni_2 = Nie2 - Nis2 + 1
+      Nj_2 = Nje2 - Njs2 + 1
+      !
+   END SUBROUTINE init_doloop
+   
    !!======================================================================
 END MODULE mppini
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LDF/ldfc1d_c2d.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LDF/ldfc1d_c2d.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LDF/ldfc1d_c2d.F90	(revision 13727)
@@ -80,13 +80,13 @@
             pah1(:,:,jk) = pahs1(:,:) * (  zratio + zc * ( 1._wp + TANH( - ( gdept_0(:,:,jk) - zh ) * zw) )  )
          END DO
-         DO_3DS_10_10( jpkm1, 1, -1 )
+         DO_3DS( 1, 0, 1, 0, jpkm1, 1, -1 )  ! pah2 at F-point (zdep2 is an approximation in zps-coord.)
             zdep2 = (  gdept_0(ji,jj+1,jk) + gdept_0(ji+1,jj+1,jk)   &
                &     + gdept_0(ji,jj  ,jk) + gdept_0(ji+1,jj  ,jk)  ) * r1_4
             pah2(ji,jj,jk) = pahs2(ji,jj) * (  zratio + zc * ( 1._wp + TANH( - ( zdep2 - zh ) * zw) )  )
          END_3D
-         CALL lbc_lnk( 'ldfc1d_c2d', pah2, 'F', 1. )   ! Lateral boundary conditions
+         CALL lbc_lnk( 'ldfc1d_c2d', pah2, 'F', 1.0_wp )   ! Lateral boundary conditions
          !
       CASE( 'TRA' )                     ! U- and V-points (zdep1 & 2 are an approximation in zps-coord.)
-         DO_3DS_10_10( jpkm1, 1, -1 )
+         DO_3DS( 1, 0, 1, 0, jpkm1, 1, -1 )
             zdep1 = (  gdept_0(ji,jj,jk) + gdept_0(ji+1,jj,jk)  ) * 0.5_wp
             zdep2 = (  gdept_0(ji,jj,jk) + gdept_0(ji,jj+1,jk)  ) * 0.5_wp
@@ -95,5 +95,5 @@
          END_3D
          ! Lateral boundary conditions
-         CALL lbc_lnk_multi( 'ldfc1d_c2d', pah1, 'U', 1. , pah2, 'V', 1. )   
+         CALL lbc_lnk_multi( 'ldfc1d_c2d', pah1, 'U', 1.0_wp , pah2, 'V', 1.0_wp )   
          !
       CASE DEFAULT                        ! error
@@ -135,10 +135,10 @@
       !
       CASE( 'DYN' )                       ! T- and F-points
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             pah1(ji,jj,1) = pUfac * MAX( e1t(ji,jj) , e2t(ji,jj) )**knn
             pah2(ji,jj,1) = pUfac * MAX( e1f(ji,jj) , e2f(ji,jj) )**knn
          END_2D
       CASE( 'TRA' )                       ! U- and V-points
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             pah1(ji,jj,1) = pUfac * MAX( e1u(ji,jj), e2u(ji,jj) )**knn
             pah2(ji,jj,1) = pUfac * MAX( e1v(ji,jj), e2v(ji,jj) )**knn
